#include "testlib.h"
#include <vector>
#include <iostream>
#include <cassert>

typedef long long int64;

#define pb push_back
#define mt make_tuple
#define all(a) (a).begin(), (a).end()
#define len(a) ((int) (a).size())
#define eprintf(...) fprintf(stderr, __VA_ARGS__)

using namespace std;

int main(int argc, char **argv) {
    registerGen(argc, argv, 1);
	int t = atoi(argv[1]);
	cout << 4 << " " << t << endl;
	vector<tuple<int, int, int>> a;
	for (int i = 0; i < 2; i++) {
		int a1 = rnd.next(9000, 10000), a2 = 1;
		int b1 = rnd.next(-10000, 10000), b2 = rnd.next(9000, 10000);
		int c2 = rnd.next(-10000, 10000), c1 = a1 * c2 - 1;
		int d = a1 * b2 - a2 * b1;
		assert(d != 0);
		printf("%d %d %d\n%d %d %d\n", a1, b1, -c1, a2, b2, -c2);
		int64 dx = 1ll * c1 * b2 - 1ll * c2 * b1, dy = 1ll * a1 * c2 - 1ll * a2 * c1;
		eprintf("d = %d; dx = %lld; dy = %lld\n", d, dx, dy);
		int64 x = 1.0 * dx / d, y = 1.0 * dy / d;
		assert(-10000 <= x && x <= 10000);
		assert(-10000 <= y && y <= 10000);
		eprintf("%.15lf, %.15lf\n", 1.0 * dx / d, 1.0 * dy / d);
		a.emplace_back(mt(a1, b1, c1));
		a.emplace_back(mt(a2, b2, c2));
	}
	vector<double> ys;
	for (auto i : a) {
		for (auto j : a) {
			int64 a1, b1, c1, a2, b2, c2;
			tie(a1, b1, c1) = i;
			tie(a2, b2, c2) = j;
			c1 = -c1, c2 = -c2;
			int64 d = a1 * b2 - a2 * b1;
			if (d == 0) {
				continue;
			}
			int64 dy = a1 * c2 - a2 * c1;
			ys.pb(1. * dy / d);
			ys.pb(-1. * dy / d);
		}
	}
	sort(all(ys));
	for (int i = 0; i < t; i++) {
		int r = rnd.next(0, len(ys) - 1);
		printf("%d %d %d\n", 0, -1, (int) (ys[i] + rnd.next(0, 1000000000) / 1e9 * (ys[i + 1] - ys[i])));
	}
	return 0;
}