import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.StringTokenizer;

public class sol_ma_long_opt {
    private final InputReader reader;
    private final OutputWriter writer;

    public sol_ma_long_opt(InputReader reader, OutputWriter writer) {
        this.reader = reader;
        this.writer = writer;
    }

    public static void main(String[] args) {
        InputReader reader = new InputReader(System.in);
        OutputWriter writer = new OutputWriter(System.out);
        new sol_ma_long_opt(reader, writer).run();
        writer.writer.flush();
    }
    
    long mydiv(long a, int b) {
        if (a >= 0)
            return a / b;
        else
            return a / b - ((a % b == 0) ? 1 : 0);
    }

    class Rational {
        long nu;
        int de;
        Rational(long nu, int de) {
            this.nu = nu;
            this.de = de;
        }
        Rational(long nu) {
            this.nu = nu;
            this.de = 1;
        }
        int compareTo(Rational other) {
            long a = nu;
            int b = de;
            long c = other.nu;
            int d = other.de;
            long p = mydiv(a, b);
            long q = mydiv(c, d);
            if (p != q)
                return Long.compare(p, q);
            a -= p * b;
            c -= q * d;
            return Long.compare(a * d, b * c);
        }
    }

    class Line {
        int a, b, c;
        int id;
        Line(int a, int b, int c, int id) {
            this.a = a;
            this.b = b;
            this.c = c;
            this.id = id;
        }
    }

    long det(Line u, Line v, Line q) {
        return ((long)u.c) * (v.a * q.b - v.b * q.a) +
               ((long)v.c) * (q.a * u.b - q.b * u.a) +
               ((long)q.c) * (u.a * v.b - u.b * v.a);
    }

    void solve(Line L[], final Line q) {
        for (Line l : L) {
            int det = l.a * q.b - l.b * q.a;
            if (det == 0) {
                throw new AssertionError();
            } else if (det < 0) {
                l.a = -l.a;
                l.b = -l.b;
                l.c = -l.c;
            }
        }
        Arrays.sort(L, new Comparator<Line>() {
            @Override
            public int compare(Line u, Line v) {
                return Long.compare(det(u, v, q), 0L);
            }
        });
        Rational d = null;
        int da = -1, db = -1;
        for (int i = 0; i < L.length - 1; i++) {
            Line u = L[i], v = L[i + 1];
            Rational x = new Rational(Math.abs(det(u, v, q)), Math.abs(u.a * v.b - v.a * u.b));
            if (d == null || d.compareTo(x) == 1) {
                d = x;
                da = u.id;
                db = v.id;
            }
        }
        writer.printf("%.20f\n", 1. * d.nu / d.de / Math.sqrt(q.a * q.a + q.b * q.b));
    }

    public void run() {
        int n = reader.nextInt();
        int t = reader.nextInt();
        Line[] L = new Line[n];
        for (int i = 0; i < n; i++) {
            int a = reader.nextInt();
            int b = reader.nextInt();
            int c = -reader.nextInt();
            L[i] = new Line(a, b, c, i);
        }
        for (int i = 0; i < t; i++) {
            int a = reader.nextInt();
            int b = reader.nextInt();
            int c = -reader.nextInt();
            Line q = new Line(a, b, c, i);
            solve(L, q);
        }
    }


    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }
    }

    static class OutputWriter {
        public PrintWriter writer;

        OutputWriter(OutputStream stream) {
            writer = new PrintWriter(stream);
        }

        public void printf(String format, Object... args) {
            writer.print(String.format(Locale.ENGLISH, format, args));
        }
    }
}
