#include <iostream>
#include <fstream>
#include <sstream>

#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <deque>
#include <string>

#include <algorithm>
#include <numeric>

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cmath>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(a) ((int) (a).size())

#ifdef CUTEBMAING
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif

using namespace std;

typedef long long int64;
typedef long double ld;
typedef unsigned long long lint;

const int inf = (1 << 30) - 1;
const int64 linf = (1ll << 62) - 1;
const int N = 1e6 + 100;

int n, t;
int a[N], b[N], c[N];

inline ld getDist(int u, int v, int w, const ld &x, const ld &y) {
	return fabsl(u * x + v * y + w);
}

inline bool intersect(int64 a1, int64 b1, int64 c1, int64 a2, int64 b2, int64 c2, ld &x, ld &y) {
	c1 = -c1, c2 = -c2;
	int64 d = a1 * b2 - a2 * b1;
	if (d == 0) {
		return false;
	}
	int64 dx = c1 * b2 - c2 * b1, dy = a1 * c2 - a2 * c1;
	x = ((ld) dx) / d;
	y = ((ld) dy) / d;
	return true;
}

inline void solve(int u, int v, int w) {
    bool s = v == 0;
	vector<pair<ld, int>> intersections;
	vector<int> parallel;
	int any = -1;
	for (int i = 0; i < n; i++) {
		ld x, y;
		if (intersect(u, v, w, a[i], b[i], c[i], x, y)) {
			intersections.push_back(make_pair(!s ? x : y, i));
			any = i;
		} else {
			parallel.push_back(i);
		}
	}
	assert(any != -1);
	sort(all(intersections));
	ld answer;
	int ansline1, ansline2;
	bool realAnswer = false;
	for (int i = 0; i < len(parallel); i++) {
		int line = parallel[i];
		ld x, y;
		if (intersect(a[line], b[line], c[line], a[any], b[any], c[any], x, y)) {
			ld dist = getDist(u, v, w, x, y);
			if (!realAnswer || dist < answer) {
				realAnswer = true;
				answer = dist;
				ansline1 = line, ansline2 = any;
			}
		}
	}
	for (int i = 0; i < len(intersections) - 1; i++) {
		int line1 = intersections[i].second, line2 = intersections[i + 1].second;
		ld x, y;
		if (intersect(a[line1], b[line1], c[line1], a[line2], b[line2], c[line2], x, y)) {
			ld dist = getDist(u, v, w, x, y);
			if (!realAnswer || dist < answer) {
				realAnswer = true;
				answer = dist;
				ansline1 = line1, ansline2 = line2;
			}
		}
	}
	assert(realAnswer);
	printf("%.20lf\n", (double) (answer / sqrt(u * u + v * v)));
}

int main() {
	cin >> n >> t;
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &a[i], &b[i], &c[i]);
	}
	for (int i = 0; i < t; i++) {
		int u, v, w; scanf("%d%d%d", &u, &v, &w);
		solve(u, v, w);
	}
    return 0;
}
