#include <iostream>
#include <fstream>
#include <sstream>

#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <deque>
#include <string>

#include <algorithm>
#include <numeric>

#include <cstdio>
#include <cassert>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <cmath>

#define pb push_back
#define pbk pop_back
#define mp make_pair
#define fs first
#define sc second
#define all(x) (x).begin(), (x).end()
#define foreach(i, a) for (__typeof((a).begin()) i = (a).begin(); i != (a).end(); ++i)
#define len(a) ((int) (a).size())

#ifdef CUTEBMAING
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif

using namespace std;

typedef long long int64;
typedef double ld;
typedef unsigned long long lint;

const int inf = (1 << 30) - 1;
const int64 linf = (1ll << 62) - 1;
const int N = 1e6 + 100;
const ld eps = 1e-9;

struct vc {
	ld x, y;
};

int n, t;
int a[N], b[N], c[N];

int line1, line2;

int lines[N], m = 0;
int parallel[N], parallelLen = 0;

pair<ld, int> inter1[N], inter2[N];

inline bool intersect(ld a1, ld b1, ld c1, ld a2, ld b2, ld c2, ld &x, ld &y) {
	c1 = -c1, c2 = -c2;
	ld d = a1 * b2 - a2 * b1;
	if (fabs(d) < eps) {
		return false;
	}
	ld dx = c1 * b2 - c2 * b1, dy = a1 * c2 - a2 * c1;
	x = dx / d;
	y = dy / d;
	return true;
}

inline bool check(ld delta, ld u, ld v, ld w) {
	bool s = fabs(v) < eps;
	ld d = sqrtl(u * u + v * v);
	u /= d, v /= d, w /= d;
	for (int t = 0; t < m; t++) {
		int i = lines[t];
		ld x, y;
		assert(intersect(u, v, w + delta, a[i], b[i], c[i], x, y));
		inter1[t] = mp(!s ? x : y, i);
		assert(intersect(u, v, w - delta, a[i], b[i], c[i], x, y));
		inter2[t] = mp(!s ? x : y, i);
	}
	sort(inter1, inter1 + m);
	sort(inter2, inter2 + m);
	for (int i = 0; i < m; i++) {
		if (inter1[i].sc != inter2[i].sc) {
			line1 = inter1[i].sc;
			line2 = inter2[i].sc;
			return true;
		}
	}
	return false;
}

void solve(int u, int v, int w) {
	m = 0;
	parallelLen = 0;
	for (int i = 0; i < n; i++) {
		if (u * b[i] - v * a[i] == 0) {
			parallel[parallelLen++] = i;
		} else {
			lines[m++] = i;
		}
	}
	assert(m > 0);
	int any = lines[0];
	pair<ld, pair<int, int>> ans = mp(1e200, mp(-1, -1));
	for (int t = 0; t < parallelLen; t++) {
		int i = parallel[t];
		ld x, y;
		if (intersect(a[any], b[any], c[any], a[i], b[i], c[i], x, y)) {
			ans = min(ans, mp(abs(u * x + v * y + w), mp(any, i)));
		}
	}
	ld l = 0, r = 1e9 + 100;
	for (int it = 0; it < 60; it++) {
		ld m = (l + r) / 2;
		if (check(m, u, v, w)) {
			r = m;
		} else {
			l = m;
		}
	}
	if (check(r, u, v, w)) {
		ld x, y;
		assert(intersect(a[line1], b[line1], c[line1], a[line2], b[line2], c[line2], x, y));
		ans = min(ans, mp(abs(u * x + v * y + w), mp(line1, line2)));
	}
	printf("%.20lf\n", ans.fs / sqrt(u * u + v * v));
}

int main() {
	cin >> n >> t;
	for (int i = 0; i < n; i++) {
		scanf("%d%d%d", &a[i], &b[i], &c[i]);
	}
	for (int i = 0; i < t; i++) {
		int u, v, w; scanf("%d%d%d", &u, &v, &w);
		solve(u, v, w);
	}
    return 0;
}
